/*************************************************************************
* ADOBE CONFIDENTIAL
* ___________________
*
* Copyright 2022 Adobe
* All Rights Reserved.
*
* NOTICE: All information contained herein is, and remains
* the property of Adobe and its suppliers, if any. The intellectual
* and technical concepts contained herein are proprietary to Adobe
* and its suppliers and are protected by all applicable intellectual
* property laws, including trade secret and copyright laws.
* Dissemination of this information or reproduction of this material
* is strictly forbidden unless prior written permission is obtained
* from Adobe.

* Adobe permits you to use and modify this file solely in accordance with
* the terms of the Adobe license agreement accompanying it.
*************************************************************************/
import { FieldJson, State } from '@aemforms/af-core';
import { JSXElementConstructor } from 'react';
import { Handlers } from './useRuleEngine';
export declare type Convertor<T> = (props: T, handlers: Handlers, localizedProperty: (propName: string) => string) => any;
export declare const translateMessage: (obj: any, formatMessage: any) => (propName: string) => any;
export declare const useFormIntl: () => any;
/**
 * Binds the component to the Form element whose state is being provided
 * @param formFieldState  The state of the Field received from Adaptive Form Component
 * @param propsMapper Mapping Field State to Props of the component
 * @param Component The component to render.
 * @param wrap
 */
export declare const useRenderer: (formFieldState: State<FieldJson>, Component: JSXElementConstructor<any>, propsMapper?: Convertor<any>, wrap?: boolean) => JSX.Element;
